package com.example.jingyuan_mes;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import com.example.jingyuan_mes.adapter.HomeMenuAdapter;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityHomePageBinding;
import com.example.jingyuan_mes.entity.MenuBeen;
import com.example.jingyuan_mes.entity.PdaRouters;
import com.example.jingyuan_mes.store.AssemblyOutActivity;
import com.example.jingyuan_mes.store.MaterialInActivity;
import com.example.jingyuan_mes.store.MaterialOutListActivity;
import com.example.jingyuan_mes.store.MaterialPassActivity;
import com.example.jingyuan_mes.store.ProductInActivity;
import com.example.jingyuan_mes.store.ProductOutActivity;
import com.example.jingyuan_mes.store.ProductOutApplyActivity;
import com.example.jingyuan_mes.store.ProductOutConfirmActivity;
import com.example.jingyuan_mes.store.StockreturnActivity;
import com.example.jingyuan_mes.store.StockreturnConfirmActivity;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HomePageActivity extends BaseActivity implements ItemClickCall {
   private List<MenuBeen> menuList;
   private HomeMenuAdapter  adapter;
   private Map<String,Class> map;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityHomePageBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_home_page);
        adapter = new HomeMenuAdapter(this,this);
        binding.setAdapter(adapter);
        initRequest();
        initMenuMap();


}

    private void initMenuMap() {
        map=new HashMap<>();
        map.put("原材料入库", MaterialInActivity.class);
        map.put("原材料出库审批", MaterialOutListActivity.class);
        map.put("原材料出库", MaterialPassActivity.class);
        map.put("组装出库", AssemblyOutActivity.class);
        map.put("原材料退库审批", StockreturnActivity.class);
        map.put("原材料退库", StockreturnConfirmActivity.class);
        map.put("成品入库", ProductInActivity.class);
        map.put("成品出库申请", ProductOutApplyActivity.class);
        map.put("成品出库", ProductOutActivity.class);
        map.put("成品出库确认", ProductOutConfirmActivity.class);
        map.put("半成品入成品库", ProductOutConfirmActivity.class);
    }

    private void initRequest() {
        menuList = new ArrayList<>();
        OkGo.<MyResult>get(url+ "/system/menu/getPdaRouters").tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            List<PdaRouters> list = gson.fromJson(body.getData().toString(), new TypeToken<List<PdaRouters>>() {
                            }.getType());
                            list.forEach(t -> {
                                MenuBeen menuBeen = new MenuBeen();
                                menuBeen.setMenuName(t.getMenuName());
                                menuBeen.setType(true);
                                menuList.add(menuBeen);
                                var children = t.getChildren();
                                if (children != null) {
                                    children.forEach(t1 -> {
                                        MenuBeen menuBeen1 = new MenuBeen();
                                        menuBeen1.setMenuName(t1.getMenuName());
                                        menuBeen1.setType(false);
                                        menuList.add(menuBeen1);
                                    });
                                }
                            });
                            adapter.setDataList(menuList);
                            adapter.notifyDataSetChanged();
                        }else {
                            Toast.makeText(HomePageActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                        }
                    }
                });
    }



    @Override
    public void onClick(int position) {
        var menuName = menuList.get(position).getMenuName();
        var cls = map.get(menuName);
        if (cls==null) return;
        startActivity(new Intent(this, cls));
    }
}