package com.example.jingyuan_mes;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.alibaba.fastjson2.JSONObject;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityMainBinding;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.example.jingyuan_mes.vm.LoginVm;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.callback.StringCallback;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class MainActivity extends BaseActivity {
    private LoginVm loginVm;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMainBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_main);
        loginVm = new LoginVm();
        boolean isRemember = SharedPreferencesUtils.getboolean("isRemember", false);
        if (isRemember) {
            loginVm.setUsername(SharedPreferencesUtils.getstring("user", ""));
            loginVm.setPassword(SharedPreferencesUtils.getstring("pass", ""));
            loginVm.setRemember(isRemember);
        }
        binding.setUser(loginVm);
    }

    @Override
    public void sanCodeCall(String code) {

    }

    public void login_click(View view) {
        String pass = loginVm.getPassword();
        String name = loginVm.getUsername();
        if (pass == null || name == null || pass.isEmpty() || name.isEmpty()) return;
        OkGo.<MyResult>post(url+"/auth/pdaLogin")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(loginVm)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            String accessToken = JSONObject.parseObject(body.getData().toString()).get("access_token").toString();
                            Log.e("TAG", "onSuccess:" + accessToken);
                            SharedPreferencesUtils.putstring("access_token",accessToken);
                            boolean remember = loginVm.isRemember();
                            if (remember) {
                                SharedPreferencesUtils.putboolean("isRemember", remember);
                                SharedPreferencesUtils.putstring("user", name);
                                SharedPreferencesUtils.putstring("pass", pass);
                            }
                            Intent intent=new Intent(MainActivity.this, HomePageActivity.class);
                            // intent.putExtra("json",response.body());
                            startActivity(intent);
                            finish();
                        }


                    }
                });
    }
}
