package com.example.jingyuan_mes.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ViewDataBinding;
import androidx.recyclerview.widget.RecyclerView;

import com.example.jingyuan_mes.BR;
import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.databinding.ItemOutListBinding;
import com.example.jingyuan_mes.entity.Outstock;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class MaterialOutAdapter extends RecyclerView.Adapter<MaterialOutAdapter.MyMaterialOutViewHolder> {
    private List<Outstock> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public MaterialOutAdapter(Context context,ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<Outstock> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyMaterialOutViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemOutListBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_out_list, parent, false);
        return new MyMaterialOutViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyMaterialOutViewHolder holder, int position) {
        var outstock = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,outstock);
        binding.outListApprove.setOnClickListener(v -> clickCall.onClick(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyMaterialOutViewHolder extends RecyclerView.ViewHolder {
        private ItemOutListBinding binding;

        public MyMaterialOutViewHolder(ItemOutListBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
