package com.example.jingyuan_mes.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.jingyuan_mes.BR;
import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.databinding.ItemOutListBinding;
import com.example.jingyuan_mes.databinding.ItemOutPassBinding;
import com.example.jingyuan_mes.entity.Outstock;
import com.example.jingyuan_mes.entity.OutstockDetail;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class MaterialOutPassAdapter extends RecyclerView.Adapter<MaterialOutPassAdapter.MyMaterialOutViewHolder> {
    private List<OutstockDetail> list;
    private Context context;
    private LayoutInflater inflater;
    public MaterialOutPassAdapter(Context context) {
        this.context = context;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<OutstockDetail> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyMaterialOutViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemOutPassBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_out_pass, parent, false);
        return new MyMaterialOutViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyMaterialOutViewHolder holder, int position) {
        var outstock = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,outstock);
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyMaterialOutViewHolder extends RecyclerView.ViewHolder {
        private ItemOutPassBinding binding;

        public MyMaterialOutViewHolder(ItemOutPassBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
