package com.example.jingyuan_mes.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.jingyuan_mes.BR;
import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.databinding.ItemProductOutConfirmBinding;
import com.example.jingyuan_mes.databinding.ItemReturnConfirmBinding;
import com.example.jingyuan_mes.entity.Outstock;
import com.example.jingyuan_mes.entity.ProductConfirm;
import com.example.jingyuan_mes.entity.ProductStock;
import com.example.jingyuan_mes.entity.RawReturn;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class ProductOutConfirmAdapter extends RecyclerView.Adapter<ProductOutConfirmAdapter.ItemtViewHolder> {
    private List<ProductConfirm> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public ProductOutConfirmAdapter(Context context, ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<ProductConfirm> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public ItemtViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemProductOutConfirmBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_product_out_confirm, parent, false);
        return new ItemtViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull ItemtViewHolder holder, int position) {
        var rawReturn = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,rawReturn);
        binding.productOutConfirmLayout.setOnClickListener(v -> clickCall.onClick(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class ItemtViewHolder extends RecyclerView.ViewHolder {
        private ItemProductOutConfirmBinding binding;

        public ItemtViewHolder(ItemProductOutConfirmBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
