package com.example.jingyuan_mes.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.jingyuan_mes.BR;
import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.databinding.ItemReturnInfoBinding;
import com.example.jingyuan_mes.entity.ProductOutstockDetail;
import com.example.jingyuan_mes.entity.RawReturnDetail;
import com.example.jingyuan_mes.store.ProductOutInfoActivity;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class ProductOutInfoAdapter extends RecyclerView.Adapter<ProductOutInfoAdapter.MyViewHolder> {
    private List<ProductOutstockDetail> list;
    private Context context;
    private LayoutInflater inflater;
    public ProductOutInfoAdapter(Context context) {
        this.context = context;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<ProductOutstockDetail> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemReturnInfoBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_return_info, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var item = list.get(position);
        item.setIndex(position+1);
        var binding = holder.binding;
        binding.setVariable(BR.vm,item);
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemReturnInfoBinding binding;

        public MyViewHolder(ItemReturnInfoBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
