package com.example.jingyuan_mes.dialog;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ViewDataBinding;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.databinding.DialogReturnBinding;
import com.example.jingyuan_mes.entity.RawReturn;

/**
 * @author wanghao
 * @date 2024/2/22  11:07
 */
public class StockReturnDialog extends Dialog {
    private DialogReturnBinding binding;
    private RawReturn rawReturn;
    private StockReturnDialogCall stockReturnDialogCall;
    private Context context;

    public void setRawReturn(RawReturn rawReturn) {
        this.rawReturn = rawReturn;
        binding.setVm(rawReturn);
        binding.auditReason.setText(null);
        // binding.executePendingBindings();
    }

    public StockReturnDialog(@NonNull Context context,StockReturnDialogCall stockReturnDialogCall) {
        super(context,R.style.dialog_style);
        this.context=context;
        this.stockReturnDialogCall=stockReturnDialogCall;
        binding = DataBindingUtil.inflate(LayoutInflater.from(context), R.layout.dialog_return, null, false);
        setContentView(binding.getRoot());
        binding.setT(this);
        binding.returnDialogDis.setOnClickListener(v -> dismiss());
    }

    public interface StockReturnDialogCall{
        void returnResult(Long rawReturnId, String auditStatus,String auditReason);
    }
    public void confirm(String state){
        var trim = binding.auditReason.getText().toString().trim();
        if (state.equals("2") && trim.isEmpty()){
            Toast.makeText(context, "必须填写审核意见", Toast.LENGTH_SHORT).show();
            return;
        }
        stockReturnDialogCall.  returnResult(rawReturn.getRawReturnId(),state,trim);
    }
}
