package com.example.jingyuan_mes.entity;

import androidx.databinding.BaseObservable;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/2/22  9:20
 */
public class RawReturn extends BaseObservable {
    /**
     * 原材料退库记录ID
     */
    private Long rawReturnId;
    /**
     * 任务编号
     */
    private String taskCode;

    private String warehouseName;
    /**
     * 申请人
     */
    private String applyBy;
    /**
     * 申请时间
     */
    private String applyDate;
    /**
     * 任务类型(1余料退料,2bom错误退料,9其他退料)
     */
    private String taskType;
    private String taskTypeName;

    private String materialName;
    /**
     * 申请原因
     */
    private String applyReason;
    private double planAmount;
    /**
     * 提交数据
     * rawReturnId : 1
     * auditStatus : 2
     * auditReason : dddd
     */
    private String auditStatus;
    private String auditReason;


    /** 计划编号 */
    private String planCode;
    private int returnAmount;
    private List<RawReturnDetail> wmsRawReturnDetailList;

    public List<RawReturnDetail> getWmsRawReturnDetailList() {
        return wmsRawReturnDetailList;
    }

    public void setWmsRawReturnDetailList(List<RawReturnDetail> wmsRawReturnDetailList) {
        this.wmsRawReturnDetailList = wmsRawReturnDetailList;
    }

    public String getPlanCode() {
        return planCode;
    }

    public void setPlanCode(String planCode) {
        this.planCode = planCode;
    }

    public int getReturnAmount() {
        return returnAmount;
    }

    public void setReturnAmount(int returnAmount) {
        this.returnAmount = returnAmount;
    }

    public String getMaterialName() {
        return materialName;
    }

    public void setMaterialName(String materialName) {
        this.materialName = materialName;

    }

    public double getPlanAmount() {
        return planAmount;
    }

    public void setPlanAmount(double planAmount) {
        this.planAmount = planAmount;
    }

    public String getTaskType() {
        return taskType;
    }

    public void setTaskType(String taskType) {
        this.taskType = taskType;
    }

    public String getTaskTypeName() {
        switch (taskType) {
            case "1":
                setTaskTypeName("余料退料");
                break;

           case "2":
                setTaskTypeName("bom错误退料");
                break;

           case "9":
                setTaskTypeName("其他退料");
                break;


        }
        return taskTypeName;
    }

    public void setTaskTypeName(String taskTypeName) {
        this.taskTypeName = taskTypeName;
        notifyChange();
    }

    public Long getRawReturnId() {
        return rawReturnId;
    }

    public void setRawReturnId(Long rawReturnId) {
        this.rawReturnId = rawReturnId;
    }

    public String getTaskCode() {
        return taskCode;
    }

    public void setTaskCode(String taskCode) {
        this.taskCode = taskCode;
    }

    public String getApplyReason() {
        return applyReason;
    }

    public void setApplyReason(String applyReason) {
        this.applyReason = applyReason;
    }

    public String getWarehouseName() {
        return warehouseName;
    }

    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName;
    }

    public String getApplyBy() {
        return applyBy;
    }

    public void setApplyBy(String applyBy) {
        this.applyBy = applyBy;
    }

    public String getApplyDate() {
        return applyDate;
    }

    public void setApplyDate(String applyDate) {
        this.applyDate = applyDate;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getAuditReason() {
        return auditReason;
    }

    public void setAuditReason(String auditReason) {
        this.auditReason = auditReason;
    }
}
