package com.example.jingyuan_mes.entity;

import androidx.databinding.BaseObservable;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * @author wanghao
 * @date 2024/2/23  16:21
 */
public class RawReturnDetail extends BaseObservable {
    /**
     * 库位编码
     */
    private int index;
    private String locationCode;
    /**
     * 物料条码
     */
    private String materialBarcode;
    /** 退库数量 */
    private int returnAmount;
    /**
     * 原材料退库记录ID
     */
    private Long rawReturnId;

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public Long getRawReturnId() {
        return rawReturnId;
    }

    public void setRawReturnId(Long rawReturnId) {
        this.rawReturnId = rawReturnId;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
        notifyChange();
    }

    public String getMaterialBarcode() {
        return materialBarcode;
    }

    public void setMaterialBarcode(String materialBarcode) {
        this.materialBarcode = materialBarcode;
        notifyChange();
    }

    public int getReturnAmount() {
        return returnAmount;
    }

    public void setReturnAmount(int returnAmount) {
        this.returnAmount = returnAmount;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        RawReturnDetail that = (RawReturnDetail) o;

        if (!Objects.equals(locationCode, that.locationCode))
            return false;
        return Objects.equals(materialBarcode, that.materialBarcode);
    }

    @Override
    public int hashCode() {
        int result = locationCode != null ? locationCode.hashCode() : 0;
        result = 31 * result + (materialBarcode != null ? materialBarcode.hashCode() : 0);
        return result;
    }
}
