package com.example.jingyuan_mes.store;

import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityMaterialInBinding;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.example.jingyuan_mes.vm.MaterialInVm;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class MaterialInActivity extends BaseActivity {
    private MaterialInVm vm;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMaterialInBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_material_in);
        binding.setTitle("原材料入库");
        vm=new MaterialInVm();
        binding.setVm(vm);

    }

    @Override
    public void sanCodeCall(String code) {
        var materialBarcode = vm.getMaterialBarcode();
        if (materialBarcode ==null|| materialBarcode.isEmpty()){
           vm.setMaterialBarcode(code);
       }else {
           vm.setLocationCode(code);
       }
    }

    public void material_in_submit(View view){
        OkGo.<MyResult>post(url+"/wms/mobile/addRawInstock")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON,gson.toJson(vm)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            finish();
                        }
                        Toast.makeText(MaterialInActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }


}