package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.MaterialOutInfoAdapter;
import com.example.jingyuan_mes.adapter.RawReturnInfoAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityMaterialOutBinding;
import com.example.jingyuan_mes.databinding.ActivityMaterialOutInfoBinding;
import com.example.jingyuan_mes.entity.OutStoreAudit;
import com.example.jingyuan_mes.entity.Outstock;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.entity.RawReturnDetail;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class MaterialOutInfoActivity extends BaseActivity {
    private OutStoreAudit auditStatus;
  private   ActivityMaterialOutInfoBinding binding;
  private MaterialOutInfoAdapter adapter;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_material_out_info);
        adapter=new MaterialOutInfoAdapter(this);
        binding.setAdapter(adapter);
    }

    @Override
    public void sanCodeCall(String code) {

    }

    @Override
    protected void onResume() {
        super.onResume();
        auditStatus=new OutStoreAudit();
        var id = getIntent().getIntExtra("id", 0);
        auditStatus.setRawOutstockId(id);
        OkGo.<MyResult>get(url+"/wms/mobile/getRawOutstockByOutstockId/"+id)
                .tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        var data = body.getData();
                        if (data !=null){
                            Outstock rawReturn=gson.fromJson(data.toString(),Outstock.class);
                            adapter.setList(rawReturn.getWmsRawOutstockDetailList());
                            adapter.notifyDataSetChanged();
                        }
                    }
                });

    }

    public void outInfoSubmit1(View view) {
        auditStatus.setAuditStatus("1");
        submit();
    }

    public void outInfoSubmit2(View view) {
        auditStatus.setAuditStatus("2");
        submit();
    }
    private void submit(){
        auditStatus.setAuditReason(binding.auditReason.getText().toString().trim());
        OkGo.<MyResult>post(url+"/wms/mobile/auditRawOutstock")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON,gson.toJson(auditStatus)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            finish();
                        }
                        Toast.makeText(MaterialOutInfoActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }

}