package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.adapter.MaterialOutAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityMaterialInBinding;
import com.example.jingyuan_mes.databinding.ActivityMaterialOutBinding;
import com.example.jingyuan_mes.entity.Outstock;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class MaterialOutListActivity extends BaseActivity implements ItemClickCall {
    private MaterialOutAdapter adapter;
    private List<Outstock> list;
    private Intent intent;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMaterialOutBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_material_out);
        adapter = new MaterialOutAdapter(this, this);
        binding.setTitle("出库审批列表");
        binding.setAdapter(adapter);
        intent=new Intent(this,MaterialOutInfoActivity.class);
    }


    @Override
    protected void onResume() {
        super.onResume();
        ininListRequest();
    }

    @Override
    public void sanCodeCall(String code) {

    }

    private void ininListRequest() {
        OkGo.<MyResult>get(url + "/wms/mobile/getToAuditedRawOutstocks")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            list=gson.fromJson(gson.toJson(body.getRows()),new TypeToken<List<Outstock>>(){}.getType());
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();
                        }else {
                            Toast.makeText(MaterialOutListActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                        }
                    }
                });
    }

    @Override
    public void onClick(int position) {
        var rawOutstockId = list.get(position).getRawOutstockId();
        intent.putExtra("id",rawOutstockId);
        startActivity(intent);

    }
}