package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.MaterialOutPassAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityMaterialPassBinding;
import com.example.jingyuan_mes.entity.OutStoreSubmit;
import com.example.jingyuan_mes.entity.OutstockDetail;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class MaterialPassActivity extends BaseActivity {
    private OutStoreSubmit vm;
    private List<OutstockDetail> list;
    private MaterialOutPassAdapter passAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMaterialPassBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_material_pass);
        vm = new OutStoreSubmit();
        binding.setVm(vm);
        passAdapter = new MaterialOutPassAdapter(this);
        binding.setAdapter(passAdapter);
        initRequest(null);
    }

    private void initRequest(String user) {
        OkGo.<MyResult>get(url + "/wms/mobile/getAuditPassRawOutstockDetails").tag(this).headers("Authorization", SharedPreferencesUtils.getstring("access_token", "")).params("applyBy", user).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getRows() == null) {
                    Toast.makeText(context, body.getCode() == 200 ? "暂无审批数据" : body.getMsg(), Toast.LENGTH_SHORT).show();
                    if (list != null) {
                        list.clear();
                        passAdapter.notifyDataSetChanged();
                    }
                    return;
                }
                list = gson.fromJson(gson.toJson(body.getRows()), new TypeToken<List<OutstockDetail>>() {}.getType());
                passAdapter.setList(list);
                passAdapter.notifyDataSetChanged();

        }
    });
}

    public void outPassSearch(View view) {
        var searchText = vm.getSearchText();
        if (searchText == null || searchText.isEmpty()) return;
        initRequest(searchText);
        vm.subClear();
    }

    public void outPassSubmit(View view) {
        var instockBatch = vm.getInstockBatch();
        var locationCode = vm.getLocationCode();
        var tag = new OutstockDetail();
        tag.setLocationCode(locationCode);
        tag.setMaterialBarcode(instockBatch);
        var index = list.indexOf(tag);
        if (index == -1) {
            Toast.makeText(this, "扫描错误", Toast.LENGTH_SHORT).show();
            return;
        }
        vm.setRawOutstockDetailId(list.get(index).getRawOutstockDetailId());
        OkGo.<MyResult>post(url + "/wms/mobile/confirmRawOutstock")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON, gson.toJson(vm)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        var body = response.body();
                        if (body.getCode() == 200) {
                            vm.subClear();
                        }
                        Toast.makeText(MaterialPassActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();

                    }
                });
    }


}