package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.adapter.ProductOutConfirmAdapter;
import com.example.jingyuan_mes.adapter.RawReturnConfirmAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityProductOutBinding;
import com.example.jingyuan_mes.entity.OutstockDetail;
import com.example.jingyuan_mes.entity.ProductConfirm;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

public class ProductOutActivity extends BaseActivity implements ItemClickCall {
    private ProductOutConfirmAdapter adapter;
    private List<ProductConfirm> list;
    private Intent intent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityProductOutBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_product_out);
        adapter = new ProductOutConfirmAdapter(this, this);
        binding.setAdapter(adapter);
        intent = new Intent(this, ProductOutInfoActivity.class);
    }

    @Override
    protected void onResume() {
        super.onResume();
        OkGo.<MyResult>get(url + "/wms/mobile/getProductOutStocks").tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getTotal() == 0) {
                            if (list != null) {
                                list.clear();
                                adapter.notifyDataSetChanged();
                            }
                            Toast.makeText(context, body.getCode()==200?"暂无审批完成数据":body.getMsg(), Toast.LENGTH_SHORT).show();
                            return;
                        }
                            list = gson.fromJson(gson.toJson(body.getRows()), new TypeToken<List<ProductConfirm>>() { }.getType());
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();

                    }
                });
    }

    @Override
    public void onClick(int position) {
        intent.putExtra("id", list.get(position).getProductOutstockId());
        startActivity(intent);
    }
}