package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableBoolean;
import androidx.databinding.ObservableField;

import android.content.Context;
import android.database.Observable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.adapter.ProductApplyAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityProductOutApplyBinding;
import com.example.jingyuan_mes.entity.ProductStock;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class ProductOutApplyActivity extends BaseActivity implements ItemClickCall {
    private ProductApplyAdapter adapter;
    private List<ProductStock> list;
    private ActivityProductOutApplyBinding binding;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_product_out_apply);
        adapter = new ProductApplyAdapter(this, this);
        binding.setAdapter(adapter);
        initRequest();
    }

    private void initRequest() {
        OkGo.<MyResult>get(url + "/wms/mobile/getProductStocksBySalesorderCode").tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .params("saleorderCode", binding.outApplySearch.getText().toString())
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getRows() == null) {
                            if (list != null) {
                                list.clear();
                                adapter.notifyDataSetChanged();
                            }
                            Toast.makeText(context, body.getCode() == 200 ? "暂无审批数据" : body.getMsg(), Toast.LENGTH_SHORT).show();
                            return;
                        }
                        list = gson.fromJson(gson.toJson(body.getRows()), new TypeToken<List<ProductStock>>() {
                        }.getType());
                        adapter.setList(list);
                        adapter.notifyDataSetChanged();

                    }
                });
    }

    public void productApplySearch(View view) {
        initRequest();
    }

    @Override
    public void onClick(int position) {
        var productStock = list.get(position);
        Log.e("TAG", "申请数量:" + productStock.getApplyQty());
        OkGo.<MyResult>post(url+"/wms/mobile/applyProductOutstock")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON,gson.toJson(productStock)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            initRequest();
                        }
                        Toast.makeText(context, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }

}