package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ProductOutInfoAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityProductOutInfoBinding;
import com.example.jingyuan_mes.entity.ProductConfirm;
import com.example.jingyuan_mes.entity.ProductOutSubmit;
import com.example.jingyuan_mes.entity.ProductOutstockDetail;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class ProductOutInfoActivity extends BaseActivity {
    private ProductOutSubmit submit;
    private ActivityProductOutInfoBinding binding;
    private ProductOutInfoAdapter adapter;
    private int id;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_product_out_info);
        id = getIntent().getIntExtra("id", 0);
        submit = new ProductOutSubmit();
        submit.setProductOutstockId(id);
        binding.setSub(submit);
        adapter=new ProductOutInfoAdapter(this);
        binding.setAdapter(adapter);
        initRequest(id);

    }

    private void initRequest(int id) {
        OkGo.<MyResult>get(url + "/wms/mobile/getProductOutStockWithDetails").tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .params("productOutstockId",id)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            ProductConfirm rawReturn = gson.fromJson(body.getData().toString(), ProductConfirm.class);
                            binding.setVm(rawReturn);
                            var wmsProductOutstockDetailList = rawReturn.getWmsProductOutstockDetailList();
                            adapter.setList(wmsProductOutstockDetailList);
                            adapter.notifyDataSetChanged();
                        }
                        Toast.makeText(context, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }


    public void productOutConfirmSubmit(View view) {
        OkGo.<MyResult>post(url + "/wms/mobile/confirmProductOutstockDetail")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON, gson.toJson(submit)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            initRequest(id);
                        }
                        Toast.makeText(context, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }
}