package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.adapter.RawReturnAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityStockreturnBinding;
import com.example.jingyuan_mes.dialog.StockReturnDialog;
import com.example.jingyuan_mes.entity.OutstockDetail;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class StockreturnActivity extends BaseActivity implements ItemClickCall, StockReturnDialog.StockReturnDialogCall {
    private RawReturnAdapter adapter;
    private List<RawReturn> list;
    private StockReturnDialog returnDialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityStockreturnBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_stockreturn);
        adapter = new RawReturnAdapter(this, this);
        binding.setAdapter(adapter);
        initRequest();
        returnDialog = new StockReturnDialog(this, this);
    }

    private void initRequest() {
        OkGo.<MyResult>get(url + "/wms/mobile/getToAuditedRawReturns").tag(this).headers("Authorization", SharedPreferencesUtils.getstring("access_token", "")).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getTotal()==0) {
                    if (list != null) {
                        list.clear();
                        adapter.notifyDataSetChanged();
                    }
                    Toast.makeText(StockreturnActivity.this, body.getCode() == 200 ? "暂无审批数据" : body.getMsg(), Toast.LENGTH_SHORT).show();
                    return;
                }
                list = gson.fromJson(gson.toJson(body.getRows()), new TypeToken<List<RawReturn>>() {}.getType());
                adapter.setList(list);
                adapter.notifyDataSetChanged();
            }
        });
    }

    @Override
    public void onClick(int position) {
        var rawReturn = list.get(position);
        OkGo.<MyResult>get(url + "/wms/mobile/getRawReturnByReturnId/" + rawReturn.getRawReturnId()).tag(this).headers("Authorization", SharedPreferencesUtils.getstring("access_token", "")).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    RawReturn rawReturn1 = gson.fromJson(body.getData().toString(), RawReturn.class);
                    returnDialog.setRawReturn(rawReturn1);
                    returnDialog.show();
                }
            }
        });

    }

    @Override
    public void returnResult(Long rawReturnId, String auditStatus, String auditReason) {

        RawReturn rawReturn = new RawReturn();
        rawReturn.setRawReturnId(rawReturnId);
        rawReturn.setAuditStatus(auditStatus);
        rawReturn.setAuditReason(auditReason);
        OkGo.<MyResult>post(url + "/wms/mobile/auditRawReturn").headers("Authorization", SharedPreferencesUtils.getstring("access_token", "")).upRequestBody(RequestBody.create(JSON, gson.toJson(rawReturn))).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 200) {
                    returnDialog.dismiss();
                    initRequest();
                }
                Toast.makeText(StockreturnActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
            }
        });
    }
}