package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.ItemClickCall;
import com.example.jingyuan_mes.adapter.RawReturnAdapter;
import com.example.jingyuan_mes.adapter.RawReturnConfirmAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityStockReturnConfirmBinding;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

public class StockreturnConfirmActivity extends BaseActivity implements ItemClickCall {
    private RawReturnConfirmAdapter adapter;
    private List<RawReturn> list;
    private Intent intent;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityStockReturnConfirmBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_stock_return_confirm);
        adapter = new RawReturnConfirmAdapter(this, this);
        binding.setAdapter(adapter);
        initRequest();
        intent = new Intent(this, StockreturnConfirmInfoActivity.class);
    }
    private void initRequest() {
        OkGo.<MyResult>get(url + "/wms/mobile/getAuditPassRawReturns").tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getRows() == null) {
                    Toast.makeText(context, body.getCode() == 200 ? "暂无审批数据" : body.getMsg(), Toast.LENGTH_SHORT).show();
                    return;
                }
                list = gson.fromJson(gson.toJson(body.getRows()), new TypeToken<List<RawReturn>>() {}.getType());
                adapter.setList(list);
                adapter.notifyDataSetChanged();
            }
        });
    }
    @Override
    public void onClick(int position) {
        intent.putExtra("id",list.get(position).getRawReturnId());
        startActivity(intent);
    }
}