package com.example.jingyuan_mes.store;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ViewDataBinding;

import android.content.pm.LauncherApps;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.example.jingyuan_mes.R;
import com.example.jingyuan_mes.adapter.RawReturnInfoAdapter;
import com.example.jingyuan_mes.base.BaseActivity;
import com.example.jingyuan_mes.base.MyRecultCall;
import com.example.jingyuan_mes.base.MyResult;
import com.example.jingyuan_mes.databinding.ActivityStockreturnConfirmInfoBinding;
import com.example.jingyuan_mes.entity.RawReturn;
import com.example.jingyuan_mes.entity.RawReturnDetail;
import com.example.jingyuan_mes.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

import okhttp3.RequestBody;

public class StockreturnConfirmInfoActivity extends BaseActivity {
    private RawReturnInfoAdapter adapter;
    private RawReturnDetail sub;
    private List<RawReturnDetail> wmsRawReturnDetailList;
    private ActivityStockreturnConfirmInfoBinding binding;
    private long id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_stockreturn_confirm_info);
        adapter = new RawReturnInfoAdapter(this);
        binding.setAdapter(adapter);
        sub = new RawReturnDetail();

        id = getIntent().getLongExtra("id", 0L);
        sub.setRawReturnId(id);
        binding.setSub(sub);

        initRequest(id);
    }

    private void initRequest(long id) {
        OkGo.<MyResult>get(url + "/wms/mobile/getRawReturnByReturnId4Confirm/" + id).tag(this)
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            RawReturn rawReturn = gson.fromJson(body.getData().toString(), RawReturn.class);
                            binding.setVm(rawReturn);
                            wmsRawReturnDetailList = rawReturn.getWmsRawReturnDetailList();
                            adapter.setList(wmsRawReturnDetailList);
                            adapter.notifyDataSetChanged();
                        }
                        Toast.makeText(context, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }

    public void returnConfirmSubmit(View view) {
        OkGo.<MyResult>post(url + "/wms/mobile/confirmRawReturn")
                .headers("Authorization", SharedPreferencesUtils.getstring("access_token", ""))
                .upRequestBody(RequestBody.create(JSON, gson.toJson(sub)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            initRequest(id);
                        }
                        Toast.makeText(context, body.getMsg(), Toast.LENGTH_SHORT).show();
                    }
                });
    }
}